unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, Grids, StdCtrls;
{$H-}
type
  TForm1 = class(TForm)
    sg: TStringGrid;
    sb: TScrollBar;
    Button1: TButton;
    procedure sbChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

function bits2str (abits : integer ): string;
function bitsum (abits : integer ) : byte;
function isbitset (abits, num : integer ) : boolean;

const
ht= ' :  0  ' ;
var
  Form1: TForm1;
  n : byte = 2; //  ,   = 2
  maxn: byte = 9; //   
  c : integer;    //    (    )

implementation

{$R *.dfm}

//     ,    ,
//    
function bits2str (abits : integer): string;
var i : byte;
begin
result := ''; //  
for i := 0 to n-1  //     
  do if isbitset(abits, i) //   
    then result := result+inttostr(i); //      
end;

//     
function bitsum (abits : integer): byte;
var i : byte;
begin
result := 0;  //  
for i := 0 to n-1  //     
  do if isbitset(abits, i) //   
    then inc(result);  // to   
end;  //        

//    
function isbitset (abits, num : integer ) : boolean;
begin  //       ,     
result := (abits and (1 shl num) = (1 shl num));
end;

//     
procedure TForm1.sbChange(Sender: TObject);
var i, j, bi : integer;
begin
autosize := true; //   
n:=sb.Position+1; //   ,   
sg.rowCount:=n+1; //  ,  1 , ..   ()
sg.Height := sg.DefaultRowHeight*(sg.RowCount+2); //   ,   
c := 1;
//      ,  
// n!/(k!(n!-k!)      
for i := n downto 1  //     
  do if i > (n+1) div 2 //        
    then c := c*i       //   (    )     
    else if not (odd(n) and (i = (n+1) div 2)) //          
      then c := c div i; //       
      
sg.ColCount := c+1; //  ,  1 
sg.DefaultColWidth := (n+1)*6; //  ,    
sb.Hint:= ht+ inttostr(n); //         
autosize := false; //   

for i := 1 to n+1 //  2      
  do sg.Cells[0,i]:=inttostr(i);
for i := 1 to c+1
  do sg.Cells[i,0]:=inttostr(i);

for i := 1 to n+1 //  2    
  do for j := 1 to c+1
    do sg.Cells[j,i] := '';


//   ,     
for i := 1 to n+1 //    (     +1)
  do begin
  bi := 1 ;  // "" 
  j := 1;
  repeat
    if bitsum(bi) = i //       =  
//    ,      I 
      then begin
      sg.Cells[j,i] := bits2str(bi); //         
      inc(j);  //          ,     
      end;
    inc(bi) //    
    until bi = 1 shl n //        
  end;
end;

//         
procedure TForm1.FormCreate(Sender: TObject);
begin
sb.Min := n;
sb.Max := maxn;
sb.ShowHint := true;
button1.caption := '  ' ;
sbchange(nil);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
showmessage('     ,  ,    ,     ');
end;

end.
